_layer_dialogs = {}


def add_layer_dialog(type, layer_class, function):
    try:
        _layer_dialogs[type][layer_class] = function
    except KeyError:
        _layer_dialogs[type] = {}
        _layer_dialogs[type][layer_class] = function
    

def init_layer_dialogs(type):
    try:
        del _layer_dialogs[type][:]
    except KeyError:
        pass


def has_layer_dialog(type, layer_class):
    return (type in _layer_dialogs and layer_class in _layer_dialogs[type])


def get_layer_properties_dialog(layer):
    for cls in _layer_dialogs['properties'].keys():
        if isinstance(layer, cls):
            return _layer_dialogs['properties'][cls]
    return None
